/*
 *  By: Sunil Kumar
 *  Cad2D Module. Module to draw simple 2D geometry objects and serialization using GeoIO module.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// CadDoc.h : interface of the CCadDoc class
//


#pragma once
#include "..\GeoIO\Layer.h"

class CCadDoc : public CDocument
{
protected: // create from serialization only
	CCadDoc();
	DECLARE_DYNCREATE(CCadDoc)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
#ifdef SHARED_HANDLERS
	virtual void InitializeSearchContent();
	virtual void OnDrawThumbnail(CDC& dc, LPRECT lprcBounds);
#endif // SHARED_HANDLERS

// Implementation
public:
	virtual ~CCadDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()

private:
	CLayer* m_pLayer;

public:
	void RefreshView(CDC* pDC);
	void AddEntity(CPrimitive* pEntity);

#ifdef SHARED_HANDLERS
	// Helper function that sets search content for a Search Handler
	void SetSearchContent(const CString& value);
#endif // SHARED_HANDLERS
};
