/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// EntityList.h: interface for the CEntityList class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __ENTITYLIST_H__
#define __ENTITYLIST_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CEntityList 
{
public:
	CPrimitive* GetEntityAtIndex(int nIndex);
	void EraseEntityNearPoint(CPoint pnt);
	void ChangeEntitiesColorInList(COLORREF clr);
	void DeleteEntity(int nEntityNum);
	CPrimitive* GetLastEntity();
	int GetEntityCount();
	void DrawEntityList(CDC *pDC, COLORREF clr);
	void AddEntity(CPrimitive *pPrimitive);
	void DeleteAllEntities();
	void DrawEntityList(CDC *pDC);
	CObList * GetEntityList();
	CEntityList();
	virtual ~CEntityList();
	void Serialize(CArchive& ar);

private:
	CTypedPtrList<CObList, CPrimitive*>m_entitylist;
	
};

#endif // __ENTITYLIST_H__
