/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoCircle.h: interface for the CGeoCircle class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GEOCIRCLE_H__
#define __GEOCIRCLE_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CGeoCircle : public CPrimitive  
{
	DECLARE_SERIAL(CGeoCircle)
public:
	float GetRadius();
	BOOL IsPointNearEntity(CPoint refPnt);
	void DeleteEntity();
	BOOL IsEntityDeleted();
	void DrawCircleForDragging(CDC *pDC, COLORREF clr);
	CGeoCircle();
	CGeoCircle(CGeoCircle& pEntity);
	virtual ~CGeoCircle();

	BOOL m_bEntityDeleted;
	COLORREF m_clr;
	CPoint m_CentrePnt;
	CPoint m_EndPnt;
	float m_fRadius;

	int m_nEntityNum;
	int m_nEntityType;

	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	CPoint GetCentrePoint(){ return m_CentrePnt;}
	
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);

private:
	void CalculateRadiusFromCentreAndEndPoints();
};

#endif // __GEOCIRCLE_H__
