// GeoLine.cpp: implementation of the CGeoLine class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeoLine.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL(CGeoLine, CObject, VERSIONABLE_SCHEMA | GEOIO_MODULE_VERSION_NUM)

CGeoLine::CGeoLine()
{
	SetEntityType(GEOIO_LINE);
}

CGeoLine::CGeoLine(CPoint stPnt, CPoint endPnt)
{
	SetStartPoint(stPnt);
	SetEndPoint(endPnt);
	SetEntityType(GEOIO_LINE);
}

CGeoLine::CGeoLine(CGeoLine& pEntity)
{
	SetEntityType(pEntity.GetEntityType());
	SetEntityNumber(pEntity.GetEntityNumber());
	SetStartPoint(pEntity.GetStartPoint());
	SetEndPoint(pEntity.GetEndPoint());
	SetEntityColor(pEntity.GetEntityColor());
}

CGeoLine::~CGeoLine()
{

}

/***********************************************************************************
		This fuction draws the line with m_StPnt as start point and
		m_EndPnt as end point. pass the DC of the view class
***********************************************************************************/
void CGeoLine::Draw(CDC *pDC)
{
	CPen pen(PS_SOLID, 0, m_clr);
	pDC->SelectObject(&pen);

	pDC->MoveTo(m_StPnt.x, m_StPnt.y);
	pDC->LineTo(m_EndPnt.x, m_EndPnt.y);
}

// store or load
void CGeoLine::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{	// storing code
		// base class will store
	}
	else
	{	// loading code
		// base class will read
	}
	CPrimitive::Serialize(ar);
}

/***********************************************************************************
	Function to determine if the point passed is near the entity
***********************************************************************************/
BOOL CGeoLine::IsPointNearEntity(CPoint refPnt)
{
	BOOL bRet = FALSE;
	return bRet;
}


void CGeoLine::DeleteEntity()
{
	SetDeleted();
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to X-axis
---------------------------------------------------------------------------------*/
void CGeoLine::MirrorAboutXaxis()
{
	/* To mirror a line about X-axis, negate the start and 
	   end points' Ycoordinate*/
	m_StPnt.y = -(m_StPnt.y);
	m_EndPnt.y = -(m_EndPnt.y);
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to y-axis
---------------------------------------------------------------------------------*/
void CGeoLine::MirrorAboutYaxis()
{
	/* To mirror a line about Y-axis, negate the start and 
	   end points' Xcoordinate*/
	m_StPnt.x = -(m_StPnt.x);
	m_EndPnt.x = -(m_EndPnt.x);
}

/*---------------------------------------------------------------------------------
	Function to clone the entity. This function returns a new pointer to
	cloned entity.
---------------------------------------------------------------------------------*/
CPrimitive* CGeoLine::CreateClone()
{
	CGeoLine* pClone = new CGeoLine(*this);
	return pClone;
}