/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoPolygon.h: interface for the CGeoPolygon class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GEOPOLYGON_H__
#define __GEOPOLYGON_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CGeoPolygon : public CPrimitive  
{
	DECLARE_SERIAL(CGeoPolygon)
public:
	CGeoPolygon();
	CGeoPolygon(CGeoPolygon& pEntity);
	virtual ~CGeoPolygon();

	int m_nNumOfSides;

	BOOL IsPointNearEntity(CPoint refPnt);
	void DeleteEntity();
	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);
	void Draw(CDC *pDC, COLORREF clr);
};

#endif // __GEOPOLYGON_H__
