/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoText.h: interface for the CGeoText class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GEOTEXT_H__
#define __GEOTEXT_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CGeoText : public CPrimitive  
{
	DECLARE_SERIAL(CGeoText)
public:
	CGeoText();
	CGeoText(CGeoText &pEntity);
	virtual ~CGeoText();
	
	CString m_strText;

	void DeleteEntity();

	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	BOOL IsPointNearEntity(CPoint refPnt);
	void PointNearEntity(CPoint pnt);
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);
	
};

#endif // __GEOTEXT_H__
